package repository

import (
	"be.ems/src/framework/database/db"
	"be.ems/src/framework/logger"
	"be.ems/src/modules/tool/model"
)

// 实例化数据层 MMLSystem 结构体
var NewMMLSystem = &MMLSystem{}

// MMLSystem MML网元命令 数据层处理
type MMLSystem struct{}

// SelectByPage 分页查询集合
func (r MMLSystem) SelectByPage(query map[string]string) ([]model.MMLSystem, int64) {
	tx := db.DB("").Model(&model.MMLSystem{})
	// 查询条件拼接
	if v, ok := query["neType"]; ok && v != "" {
		tx = tx.Where("ne_type = ?", v)
	}
	if v, ok := query["status"]; ok && v != "" {
		tx = tx.Where("status = ?", v)
	}

	// 查询结果
	var total int64 = 0
	rows := []model.MMLSystem{}

	// 查询数量为0直接返回
	if err := tx.Count(&total).Error; err != nil || total <= 0 {
		return rows, total
	}

	// 查询数据分页
	pageNum, pageSize := db.PageNumSize(query["pageNum"], query["pageSize"])
	tx = tx.Limit(pageSize).Offset(pageSize * pageNum)
	err := tx.Find(&rows).Error
	if err != nil {
		logger.Errorf("query find err => %v", err.Error())
		return rows, total
	}
	return rows, total
}
